#!/etc/opt/openit/perl
use Cwd;

my $cwd = getcwd();
my $file = `$cwd/files/scripts/get_conf.sh`;
chomp $file;
$file = $file . "/filtrator/licenseevents-log-v2.conf";

@lines = read_file( $file );

# Main modify subroutines -----------

sub modify_filterprocess
{
	print "Modifying filter-process()...\n";

	#Add new filter-process
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$fiterprocess/g;

	$insert = "filter-process()=\"\"
	{
		Mapping:license-manager()=\"\"
		{
			Threshold:empty-event()=\"\"
			{
				Mapping:mark-empty-feature()=\"\"
				{
					Mapping:fix-valid-empty-feature()=\"\"
					{
						Threshold:remove-empty-features()=\"\"
						{
							Mapping:status()=\"\"
							{
								Duplicate:products()=\"\"
								{
									Duplicate:features()=\"\"
									{
										Summarize:count()=\"\"
										{
											Report()=\"\"{}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}";

	$index = 0;
	$proc_index = locate_line( $index, "filter-process", \@lines );
	$defs_index = locate_line( $index, "filter-defs", \@lines );

	# Remove filter-process block
	for ( $i = $proc_index+1; $i <= $defs_index-1; $i++ )
	{
		@lines[$i] =~ s/\S|\s+//g;
	}

	#Add new filter-process block
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$insert/g;

	print "\tDone modifying filter-process()\n";
}

sub insert_filterdefs  #Insert whole block of filter-defs
{
	my ( $defs, $block ) = (@_);

	print "Inserting $defs...\n";

	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, $defs, \@lines );
	if( $index < $defs_index )
	{
		#Check lines one by one
		print "\t$defs already exist\n";
	}
	else
	{
		@lines[$index+1] .= $block;
		print "\tDone inserting $defs\n";
	}
}

sub modify_filterdefs
{
	my ( $defs_index, $pattern, $insert ) = (@_);
	$defs_index = locate_line( $defs_index, $pattern, \@lines );

	my ($string) = @lines[$defs_index] =~ /([^\t\b\n]+)/;
	#print "$string\n";
	#print "$insert\n";	

	if ( $string eq $insert )
	{
	 	print "\t\t$pattern is already updated.\n";
	 	#print "Equal\n";
	}
	else
	{
	 	@lines[$defs_index] =~ s/.\S*//g;
	 	@lines[$defs_index-1] .= "\t\t\t$insert";
	 	print "\t\tDone updating $pattern\n";
	 	#print "Not equal\n";
	}
}

# Modify subroutines -----------

sub modify_ThresholdEmptyEvent
{
	$title = "Threshold:empty-event";
	$insert = "		Threshold:empty-event()=\"\"
		{
			filter(String)=\"Threshold\"{}
			limiting(String)=\"\$event_type == ' '\"{}
			index(String)=\"event_type\"{}
			value(String)=\"\"{}
			method(String)=\"seq\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_MappingFixValidEmptyFeature
{
	print "Modifying object in Mapping:fix-valid-empty-feature()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:fix-valid-empty-feature", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$close = $open;

	 	while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}	 	

	 	$object_index = locate_line( $open, "simple-map", \@lines );
	 	print "\tChecking object: simple-map\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "simple-map", "simple-map(String)=\"'lumevents'='LUM server','pelotonevents'='PELOTON server'\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tsimple-map(String)=\"'lumevents'='LUM server','pelotonevents'='PELOTON server'\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tMapping:fix-valid-empty-feature() doesn't exist\n";
	}
}

sub modify_SummarizeCount
{
	print "Modifying object in Summarize:count()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Summarize:count", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$close = $open;

	 	while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}	 	

	 	$object_index = locate_line( $open, "compare", \@lines );
	 	print "\tChecking object: compare\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "compare", "compare(String)=\"start,product,package,feature,feature_version,user,host,event_type,event_subtype,data_type,details\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tcompare(String)=\"start,product,package,feature,feature_version,user,host,event_type,event_subtype,data_type,details\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tSummarize:count() doesn't exist\n";
	}
}

sub modify_Report
{
	print "Modifying object in Report()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Report", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$close = $open;

	 	while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}	 	

	 	$object_index = locate_line( $open, "classifications", \@lines );
	 	print "\tChecking object: classifications\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "classifications", "classifications(String)=\"interval:start:'104':'0':product:'0':package:'0':feature:'0':feature_version:'0':event_type:'0':event_subtype:'0':user:'0':host:'0':details\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tclassifications(String)=\"interval:start:'104':'0':product:'0':package:'0':feature:'0':feature_version:'0':event_type:'0':event_subtype:'0':user:'0':host:'0':details\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tReport() doesn't exist\n";
	}
}

sub modify_MapppingStatus
{
	print "Modifying object in Mapping:status()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:status", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "inactive", \@lines );
		print "\tChecking object: inactive\n";
		if ( $close > $object_index &&  $object_index != '' )
		{
			@lines[$object_index] =~ s/.\S*//g;
			print "\t\tDone removing object.\n";
		}
		else
		{
			print "\t\tObject doesn't exist.\n";
		}
	}
	else
	{
		print "\tMapping:status() doesn't exist\n";
	}
}

sub modify_MappingRenameSoftwareId
{
	print "Modifying object in Mapping:rename-software-id()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:rename-software-id", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		# Remove filter-process block
		for ( $i = $defs_index; $i <= $close; $i++ )
		{
			@lines[$i] =~ s/\S|\s+//g;
		}
		
		print "\t\tDone removing object.\n";
	}
	else
	{
		print "\tMapping:rename-software-id() doesn't exist\n";
	}
}

modify_filterprocess;
modify_ThresholdEmptyEvent;
modify_MappingFixValidEmptyFeature;
modify_SummarizeCount;
modify_Report;
modify_MapppingStatus;
modify_MappingRenameSoftwareId;

save_file( $file, 2165, @lines );

# Subroutines -----------
sub read_file {
	my ( $cfg ) = @_;
	open( IN, "$cfg" ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	# For carets and colons, use the . character to represent them
	# For the 3rd argument, always add a \ as prefix to the array
	my ( $start, $find, $lines_ref ) = (@_);
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";
	
	open( OUT, ">$new" ) || die "ERROR: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) ) {
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!\n";
	}
	
	if( ! rename( $new, $cfg ) ) {
		die "ERROR: Unable to rename new config to '$cfg'!\n";
	}
}
