#!/etc/opt/openit/perl
use Cwd;

my $cwd = getcwd();
my $file = `$cwd/files/scripts/get_conf.sh`;
chomp $file;
$file = $file . "/filtrator/licenseevents-denied.conf";
@lines = read_file( $file );

# Main modify subroutines -----------

sub modify_type
{

	print "Modifying type value...\n";

	$index = 0;
	$index = locate_line( $index, "type", \@lines );

	if( @lines[$index] !~ /licenseevents2/ )
	{
	 	@lines[$index] =~ s/licenseevents/licenseevents2/g;
	 	print "\tDone modifying type\n";
	}
	else
	{
		print "\tType is already updated. No need to modify\n";
	}
}

sub modify_filterprocess
{
	print "Modifying filter-process()...\n";

	#Add new filter-process
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$fiterprocess/g;

	$insert = "filter-process()=\"\"
	{
		Mapping:status()=\"\"
		{
			Threshold:delete()=\"\"
			{
				EventFrameDetector:false_denials()=\"\"
				{
					CollapseEvents:false_denials()=\"\"
					{
						Mapping:rename-software-id()=\"\"
						{
							Duplicate:products()=\"\"
							{
								Duplicate:features()=\"\"
								{
									Mapping:duration()=\"\"
									{
										RemoveClass()=\"\"
										{
											Mapping:primetime()=\"\"
											{
												Summarize()=\"\"
												{
													Threshold:no-normal()=\"\"
													{
														Report()=\"\"{}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}";

	$index = 0;
	$proc_index = locate_line( $index, "filter-process", \@lines );
	$defs_index = locate_line( $index, "filter-defs", \@lines );

	# Remove filter-process block
	for ( $i = $proc_index+1; $i <= $defs_index-1; $i++ )
	{
		@lines[$i] =~ s/\S|\s+//g;
	}

	#Add new filter-process block
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$insert/g;

	print "\tDone modifying filter-process()\n";
}

sub insert_filterdefs  #Insert whole block of filter-defs
{
	my ( $defs, $block ) = (@_);

	print "Inserting $defs...\n";

	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, $defs, \@lines );
	if( $index < $defs_index )
	{
		#Check lines one by one
		print "\t$defs already exist\n";
	}
	else
	{
		@lines[$index+1] .= $block;
		print "\tDone inserting $defs\n";
	}
}

sub modify_filterdefs
{
	my ( $defs_index, $pattern, $insert ) = (@_);
	$defs_index = locate_line( $defs_index, $pattern, \@lines );

	my ($string) = @lines[$defs_index] =~ /([^\t\b\n]+)/;
	#print "$string\n";
	#print "$insert\n";	

	if ( $string eq $insert )
	{
	 	print "\t\t$pattern is already updated.\n";
	 	#print "Equal\n";
	}
	else
	{
	 	@lines[$defs_index] =~ s/.\S*//g;
	 	@lines[$defs_index-1] .= "\t\t\t$insert";
	 	print "\t\tDone updating $pattern\n";
	 	#print "Not equal\n";
	}
}

# Modify subroutines -----------

sub modify_EventFrameDetector
{
	$title = "EventFrameDetector:false_denials";
	$insert = "		EventFrameDetector:false_denials()=\"\"
		{
			inactive(Bool)=\"false\"{}
			filter(String)=\"EventFrameDetector\"{}
			signature(String)=\"feature,host,user\"{}
			before-event(TimeSpan)=\"P5S\"{}
			after-event(TimeSpan)=\"P2S\"{}
			frame-event-type(String)=\"status=='out'\"{}
			detected-event-field(String)=\"status=='denied'\"{}
			detected-action(String)=\"status='false-denial-local'\"{}
			exception-identifier(String)=\"product\"{}
			exception-save(String)=\"var7\"{}
			exception-detected-action(String)=\"status='false-denial'\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_CollapseEvents 
{
	$title = "CollapseEvents:false_denials";
	$insert = "		CollapseEvents:false_denials()=\"\"
		{
			inactive(Bool)=\"false\"{}
			filter(String)=\"CollapseEvents\"{}
			signature(String)=\"feature,host,user,status\"{}
			time-window-size(TimeSpan)=\"PT5M\"{}
			limiting(String)=\"\$status=='denied'|\$status=='false-denial'|\$status=='false-denial-local'\"{}
			new-time(String)=\"first\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_Threshold
{
	$title = "Threshold:delete";
	$insert = "		Threshold:delete()=\"\"
		{
			filter(String)=\"Threshold\"{}
			index(String)=\"status\"{}
			value(String)=\"delete\"{}
			method(String)=\"sne\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_MappingStatus
{
	print "Modifying object in Mapping:status()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:status", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$close = $open;

	 	while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}	 	

	 	$object_index = locate_line( $open, "simple-map", \@lines );
	 	print "\tChecking object: simple-map\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "simple-map", "simple-map(String)=\"'1'='delete','2'='delete','3'='out','4'='in','5'='delete','6'='delete','7'='delete','20'='denied','21'='unsupported','22'='queued','30'='RELOAD LICENSE'\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tsimple-map(String)=\"'1'='delete','2'='delete','3'='out','4'='in','5'='delete','6'='delete','7'='delete','20'='denied','21'='unsupported','22'='queued','30'='RELOAD LICENSE'\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tMapping:status() doesn't exist\n";
	}
}

sub modify_MappingPrimetime
{
	print "Modifying object in Mapping:primetime()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:primetime", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "simple-map", \@lines );
		print "\tChecking object: simple-map\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "simple-map", "simple-map(String)=\"*='undef'\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tsimple-map(String)=\"*='undef'\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:primetime() doesn't exist\n";
	}
}

sub modify_MappingRenameSoftwareID
{
	print "Modifying object in Mapping:rename-software-id()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:rename-software-id", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "set-value", \@lines );
		print "\tChecking object: set-value\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "set-value", "set-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tset-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:rename-software-id() doesn't exist\n";
	}
}

sub modify_ThresholdNoNormal
{
	print "Modifying objects in Threshold:no-normal()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Threshold:no-normal", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "value", \@lines );
		print "\tChecking object: value\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "value", "value(String)=\"\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tvalue(String)=\"\"{}\n";
			print "\t\tDone inserting object.\n";
		}

		$object_index = locate_line( $open, "method", \@lines );
		print "\tChecking object: method\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "method", "method(String)=\"seq\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tmethod(String)=\"seq\"{}\n";
			print "\t\tDone inserting object.\n";
		}

		$object_index = locate_line( $open, "inactive", \@lines );
		print "\tChecking object: inactive\n";
		if ( $close > $object_index && $object_index != "" )
		{
			modify_filterdefs( $object_index, "inactive", "inactive(Bool)=\"false\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tinactive(Bool)=\"false\"{}\n";
			print "\t\tDone inserting object.\n";
		}

		$object_index = locate_line( $open, "limiting", \@lines );
		print "\tChecking object: limiting\n";
		if ( $close > $object_index && $object_index != "" )
		{
			modify_filterdefs( $object_index, "limiting", "limiting(String)=\"\$status == 'in' | \$status == 'out' | \$status == ' '\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tlimiting(String)=\"\$status == 'in' | \$status == 'out' | \$status == ' '\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tThreshold:no-normal() doesn't exist\n";
	}
}

modify_type;
modify_filterprocess;
modify_EventFrameDetector;
modify_CollapseEvents;
modify_Threshold;
modify_MappingStatus;
modify_MappingPrimetime;
modify_MappingRenameSoftwareID;
modify_ThresholdNoNormal;

save_file( $file, 2165, @lines );

# Subroutines -----------
sub read_file {
	my ( $cfg ) = @_;
	open( IN, "$cfg" ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	# For carets and colons, use the . character to represent them
	# For the 3rd argument, always add a \ as prefix to the array
	my ( $start, $find, $lines_ref ) = (@_);
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";
	
	open( OUT, ">$new" ) || die "ERROR: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) ) {
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!\n";
	}
	
	if( ! rename( $new, $cfg ) ) {
		die "ERROR: Unable to rename new config to '$cfg'!\n";
	}
}
