#!/etc/opt/openit/perl
use Cwd;

my $cwd = getcwd();
my $file = `$cwd/files/scripts/get_conf.sh`;
chomp $file;
$file = $file . "/filtrator/licenseevents-total-usage.conf";
@lines = read_file( $file );

# Main modify subroutines -----------

sub modify_filterprocess
{
	print "Modifying filter-process()...\n";

	#Add new filter-process
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$fiterprocess/g;

	$insert = "filter-process()=\"\"
	{
		Threshold:zero-duration()=\"\"
		{
			Summarize:duplicates()=\"\"
			{
				Summarize:merge-share-handles()=\"\"
				{
					Mapping:rename-software-id()=\"\"
					{
						Duplicate:products()=\"\"
						{
							CalcSum:product()=\"\"
							{
								Duplicate:features()=\"\"
								{
									CalcSum:feature()=\"\"
									{
										Duplicate:license-usage()=\"\"
										{
											CalcSum:license-usage-all()=\"\"
											{
												Mapping:available-licenses()=\"\"
												{
													Concurrent:feature()=\"\"
													{
														GenerateFields:utilization()=\"\"
														{
															GenerateFields:elapsed-time()=\"\"
															{
																Mapping:primetime()=\"\"
																{
																	Report:total-license-usage()=\"\"{}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}";

	$index = 0;
	$proc_index = locate_line( $index, "filter-process", \@lines );
	$defs_index = locate_line( $index, "filter-defs", \@lines );

	# Remove filter-process block
	for ( $i = $proc_index+1; $i <= $defs_index-1; $i++ )
	{
		@lines[$i] =~ s/\S|\s+//g;
	}

	#Add new filter-process block
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$insert/g;

	print "\tDone modifying filter-process()\n";
}

sub insert_filterdefs  #Insert whole block of filter-defs
{
	my ( $defs, $block ) = (@_);

	print "Inserting $defs...\n";

	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, $defs, \@lines );
	if( $index < $defs_index )
	{
		#Check lines one by one
		print "\t$defs already exist\n";
	}
	else
	{
		@lines[$index+1] .= $block;
		print "\tDone inserting $defs\n";
	}
}

sub modify_filterdefs
{
	my ( $defs_index, $pattern, $insert ) = (@_);
	$defs_index = locate_line( $defs_index, $pattern, \@lines );

	my ($string) = @lines[$defs_index] =~ /([^\t\b\n]+)/;
	#print "$string\n";
	#print "$insert\n";	

	if ( $string eq $insert )
	{
	 	print "\t\t$pattern is already updated.\n";
	 	#print "Equal\n";
	}
	else
	{
	 	@lines[$defs_index] =~ s/.\S*//g;
	 	@lines[$defs_index-1] .= "\t\t\t$insert";
	 	print "\t\tDone updating $pattern\n";
	 	#print "Not equal\n";
	}
}

# Modify subroutines -----------

sub modify_MappingRenameSoftwareID
{
	print "Modifying object in Mapping:rename-software-id()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:rename-software-id", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "set-value", \@lines );
		print "\tChecking object: set-value\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "set-value", "set-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tset-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:rename-software-id() doesn't exist\n";
	}
}

sub modify_SummarizeDuplicates
{
	$title = "Summarize:duplicates";
	$insert = "		Summarize:duplicates()=\"\"
		{
			inactive(Bool)=\"false\"{}
			filter(String)=\"Summarize\"{}
			align(TimeSpan)=\"PT0\"{}
			compare(String)=\"start,duration,product,feature,feature_version,host,user\"{}
			summarize(String)=\"var6\"{}
			limit(String)=\"\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_SummarizeMergeShareHandles 
{
	$title = "Summarize:merge-share-handles";
	$insert = "		Summarize:merge-share-handles()=\"\"
		{
			filter(String)=\"Summarize\"{}
			align(TimeSpan)=\"P1H\"{}
			compare(String)=\"product,feature,feature_version,licenses,used_licenses,share_handle\"{}
			summarize(String)=\"duration\"{}
			limit(String)=\"product='*;rlm'\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_ConcurrentFeature
{
	print "Modifying object in Concurrent:feature()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Concurrent:feature", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "compare", \@lines );
		print "\tChecking object: compare\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "compare", "compare(String)=\"status,product,feature,feature_version,licenses\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tcompare(String)=\"status,product,feature,feature_version,licenses\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:primetime() doesn't exist\n";
	}
}

sub modify_MapppingPrimetime
{
	print "Modifying object in Mapping:primetime()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:primetime", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "simple-map", \@lines );
		print "\tChecking object: simple-map\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "simple-map", "simple-map(String)=\"' '='undef','0'='non-prime','1'='prime'\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tsimple-map(String)=\"' '='undef','0'='non-prime','1'='prime'\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:primetime() doesn't exist\n";
	}
}

sub modify_MapppingAvailableLicenses
{
	print "Modifying object in Mapping:available-licenses()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:available-licenses", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;		
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "set-value", \@lines );
		print "\tChecking object: set-value\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "set-value", "set-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tset-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}\n";
			print "\t\tDone inserting object.\n";
		}

		$object_index = locate_line( $open, "inactive", \@lines );
		print "\tChecking object: inactive\n";
		if ( $close > $object_index &&  $object_index != '' )
		{
			@lines[$object_index] =~ s/.\S*//g;
			print "\t\tDone removing object.\n";
		}
		else
		{
			print "\t\tObject doesn't exist.\n";
		}
	}
	else
	{
		print "\tMapping:primetime() doesn't exist\n";
	}
}

sub modify_CalcSumProduct
{
	print "Modifying object in CalcSum:product()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "CalcSum:product", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$next_open = $open+1;

	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$next_open = $close;
	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$object_index = locate_line( $open, "compare", \@lines );
	 	print "\tChecking object: compare\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "compare", "compare(String)=\"status,product,feature,feature_version,origsource\"");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tcompare(String)=\"status,product,feature,feature_version,origsource\"\n";
			print "\t\tDone inserting object.\n";
	 	}

	 	$object_index = locate_line( $open, "remove", \@lines );
	 	print "\tChecking object: remove\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "remove", "remove(String)=\"origsource\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tremove(String)=\"origsource\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}

	 	$object_index = locate_line( $open, "summarize", \@lines );
	 	print "\tChecking object: summarize\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "summarize", "summarize(String)=\"licenses\"");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tsummarize(String)=\"licenses\"\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tCalcSum:product() doesn't exist\n";
	}
}

sub modify_CalcSumFeature
{
	print "Modifying object in CalcSum:feature()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "CalcSum:feature", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$next_open = $open+1;

	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$next_open = $close;
	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$object_index = locate_line( $open, "compare", \@lines );
	 	print "\tChecking object: compare\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "compare", "compare(String)=\"status,product,feature,feature_version,origsource\"");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tcompare(String)=\"status,product,feature,feature_version,origsource\"\n";
			print "\t\tDone inserting object.\n";
	 	}

	 	$object_index = locate_line( $open, "remove", \@lines );
	 	print "\tChecking object: remove\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "remove", "remove(String)=\"origsource\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tremove(String)=\"origsource\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}

	 	$object_index = locate_line( $open, "summarize", \@lines );
	 	print "\tChecking object: summarize\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "summarize", "summarize(String)=\"licenses\"");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tsummarize(String)=\"licenses\"\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tCalcSum:feature() doesn't exist\n";
	}
}

sub modify_CalcLicenseUsageAll
{
	print "Modifying object in CalcSum:license-usage-all()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "CalcSum:license-usage-all", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$next_open = $open+1;

	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$next_open = $close;
	 	while ( @lines[$next_open] !~ /([^"{\w]{)/ )
 		{
 			$next_open++;
 		}

 		$close = $next_open;
 		while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}

	 	$object_index = locate_line( $open, "compare", \@lines );
	 	print "\tChecking object: compare\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "compare", "compare(String)=\"product,feature,feature_version,origsource\"");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tcompare(String)=\"product,feature,feature_version,origsource\"\n";
			print "\t\tDone inserting object.\n";
	 	}
	}
	else
	{
		print "\tCalcSum:license-usage-all() doesn't exist\n";
	}
}

modify_filterprocess;
modify_MappingRenameSoftwareID;
modify_SummarizeDuplicates;
modify_SummarizeMergeShareHandles;
modify_ConcurrentFeature;
modify_MapppingPrimetime;
modify_MapppingAvailableLicenses;
modify_CalcSumProduct;
modify_CalcSumFeature;
modify_CalcLicenseUsageAll;

save_file( $file, 2165, @lines );

# Subroutines -----------
sub read_file {
	my ( $cfg ) = @_;
	open( IN, "$cfg" ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	# For carets and colons, use the . character to represent them
	# For the 3rd argument, always add a \ as prefix to the array
	my ( $start, $find, $lines_ref ) = (@_);
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";
	
	open( OUT, ">$new" ) || die "ERROR: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) ) {
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!\n";
	}
	
	if( ! rename( $new, $cfg ) ) {
		die "ERROR: Unable to rename new config to '$cfg'!\n";
	}
}
