#!/etc/opt/openit/perl
use Cwd;

my $cwd = getcwd();
my $file = `$cwd/files/scripts/get_conf.sh`;
chomp $file;
$file = $file . "/filtrator/licenseevents-individual-usage.conf";
@lines = read_file( $file );

# Main modify subroutines -----------

sub modify_filterprocess
{
	print "Modifying filter-process()...\n";

	#Add new filter-process
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$fiterprocess/g;

	$insert = "filter-process()=\"\"
	{
		Threshold:zero-duration()=\"\"
		{
			Summarize:merge-share-handles()=\"\"
			{
				Mapping:rename-software-id()=\"\"
				{
					Duplicate:features()=\"\"
					{
						CalcSum:feature()=\"\"
						{
							Duplicate:license-usage()=\"\"
							{
								Concurrent:feature()=\"\"
								{
									GenerateFields:elapsed-time()=\"\"
									{
										Summarize:license-usage()=\"\"
										{
											Mapping:primetime()=\"\"
											{
												Report:individual-license-usage()=\"\"{}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}";

	$index = 0;
	$proc_index = locate_line( $index, "filter-process", \@lines );
	$defs_index = locate_line( $index, "filter-defs", \@lines );

	# Remove filter-process block
	for ( $i = $proc_index+1; $i <= $defs_index-1; $i++ )
	{
		@lines[$i] =~ s/\S|\s+//g;
	}

	#Add new filter-process block
	@lines[$proc_index] =~ s/filter-process\(\)=\"\"/$insert/g;

	print "\tDone modifying filter-process()\n";
}

sub insert_filterdefs  #Insert whole block of filter-defs
{
	my ( $defs, $block ) = (@_);

	print "Inserting $defs...\n";

	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, $defs, \@lines );
	if( $index < $defs_index )
	{
		#Check lines one by one
		print "\t$defs already exist\n";
	}
	else
	{
		@lines[$index+1] .= $block;
		print "\tDone inserting $defs\n";
	}
}

sub modify_filterdefs
{
	my ( $defs_index, $pattern, $insert ) = (@_);
	$defs_index = locate_line( $defs_index, $pattern, \@lines );

	my ($string) = @lines[$defs_index] =~ /([^\t\b\n]+)/;
	#print "$string\n";
	#print "$insert\n";	

	if ( $string eq $insert )
	{
	 	print "\t\t$pattern is already updated.\n";
	 	#print "Equal\n";
	}
	else
	{
	 	@lines[$defs_index] =~ s/.\S*//g;
	 	@lines[$defs_index-1] .= "\t\t\t$insert";
	 	print "\t\tDone updating $pattern\n";
	 	#print "Not equal\n";
	}
}

# Modify subroutines -----------

sub modify_Summarize
{
	$title = "Summarize:merge-share-handles";
	$insert = "		Summarize:merge-share-handles()=\"\"
		{
			filter(String)=\"Summarize\"{}
			align(TimeSpan)=\"P1H\"{}
			compare(String)=\"product,feature,feature_version,licenses,used_licenses,share_handle\"{}
			summarize(String)=\"duration\"{}
			limit(String)=\"product='*;rlm'\"{}
		}\n";

	insert_filterdefs( $title, $insert );
}

sub modify_ConcurrentFeature
{
	print "Modifying object in Concurrent:feature()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Concurrent:feature", \@lines );

	if( $index < $defs_index )
	{
	 	$open = $defs_index+1;
	 	$close = $open;

	 	while ( @lines[$close] !~ /([^{\w]})/ )
	 	{
	 		$close++;
	 	}	 	

	 	$object_index = locate_line( $open, "zero-count", \@lines );
	 	print "\tChecking object: zero-count\n";
		if ( $close > $object_index )
	 	{
	 		modify_filterdefs( $object_index, "zero-count", "zero-count(Bool)=\"false\"{}");
	 	}
	 	else
	 	{
	 		@lines[$close-1] .= "\t\t\tzero-count(Bool)=\"false\"{}\n";
			print "\t\tDone inserting object.\n";
	 	}

	 	$object_index = locate_line( $open, "compare", \@lines );
		print "\tChecking object: compare\n";

		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "compare", "compare(String)=\"status,product,feature,feature_version,user,host,tty,licenses,primetime\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tcompare(String)=\"status,product,feature,feature_version,user,host,tty,licenses,primetime\"{}\n";
			print "\t\tDone inserting object.\n";
		}

		$object_index = locate_line( $open, "keytype", \@lines );
		print "\tChecking object: keytype\n";
		if ( $close > $object_index &&  $object_index != '' )
		{
			@lines[$object_index] =~ s/.\S*//g;
			print "\t\tDone removing object.\n";
		}
		else
		{
			print "\t\tObject doesn't exist.\n";
		}
	}
	else
	{
		print "\tConcurrent:feature() doesn't exist\n";
	}
}

sub modify_MappingRenameSoftwareID
{
	print "Modifying object in Mapping:rename-software-id()...\n";
	$index = 0;
	$index = locate_line( $index, "filter-defs", \@lines );
	$defs_index = locate_line( $index, "Mapping:rename-software-id", \@lines );

	if( $index < $defs_index )
	{
		$open = $defs_index+1;
		$close = $open;

		while ( @lines[$close] !~ /([^{\w]})/ )
		{
			$close++;
		}

		$object_index = locate_line( $open, "set-value", \@lines );
		print "\tChecking object: set-value\n";
		if ( $close > $object_index )
		{
			modify_filterdefs( $object_index, "set-value", "set-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}");
		}
		else
		{
			@lines[$close-1] .= "\t\t\tset-value(String)=\"#1:var4=\$feature . '\\\\\\\\' . \$product\"{}\n";
			print "\t\tDone inserting object.\n";
		}
	}
	else
	{
		print "\tMapping:rename-software-id() doesn't exist\n";
	}
}

modify_filterprocess;
modify_Summarize;
modify_ConcurrentFeature;
modify_MappingRenameSoftwareID;

save_file( $file, 2165, @lines );

# Subroutines -----------
sub read_file {
	my ( $cfg ) = @_;
	open( IN, "$cfg" ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	# For carets and colons, use the . character to represent them
	# For the 3rd argument, always add a \ as prefix to the array
	my ( $start, $find, $lines_ref ) = (@_);
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";
	
	open( OUT, ">$new" ) || die "ERROR: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) ) {
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!\n";
	}
	
	if( ! rename( $new, $cfg ) ) {
		die "ERROR: Unable to rename new config to '$cfg'!\n";
	}
}
