#!/etc/opt/openit/perl

use strict;
use warnings;
use Cwd;

my $cwd = getcwd();
system( "$cwd/files/scripts/update_daft.pl" );

my $command = `$cwd/files/scripts/get_version.sh`;
chomp $command;

open (my $fh, '<', $command) or die "Unable to read '$command'!";
my $line;
while ($line = <$fh>)
{
	chomp $line;
	if ($line =~ /^VERSION/)
	{
		$line =~ s/VERSION//g;
		last;
	}
}
close $fh;
$line =~ s/^\s+//;

my @dts = (89, 90, 91, 104, 107, 108, 109);
if ($line eq "6.4.0.9")
{
	# Run scripts for 6.4.0.9
	foreach ( @dts )
	{
		system( "$cwd/files/scripts/$_/6409/$_.pl" );
	}
}

if ($line eq "6.5.0.22")
{
	# Run scripts for version 6.5.0.22 
	foreach ( @dts )
	{
		system( "$cwd/files/scripts/$_/65022/$_.pl" );
	}
}

if ($line eq "6.5.1.14")
{
	# Run scripts for version 6.5.1.14
	foreach ( @dts )
	{
		system( "$cwd/files/scripts/$_/65114/$_.pl" );
	}
}
