#!/etc/opt/openit/perl

use File::Basename;

$dirname = dirname( __FILE__ );
$file = `$dirname/get_conf.sh`;
chomp $file;

$daft = $file . "/daft.conf";
@lines = read_file( $daft );
$index = 0;

$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licenseevents.String", \@lines );

if( @lines[$index] =~ /licenseevents-denied/ )
{
	@lines[$index] =~ s/,licenseevents-denied \$BEG \$END P1D//g;
}

$index = locate_line( $index, "licenseevents2.String", \@lines );

if( @lines[$index] !~ /licenseevents-denied/ )
{
	@lines[$index] =~ s/\)="/\)="licenseevents-denied \$BEG \$END P1D,/g;
}

# Replacements
$licenseevents_repl = "LogParserSentinel.license.record,LogParserOrcaflex.license.record,LogParserFekete.license.record,LogParserCodeMtr.license.record,LogParserRLM.license.record,LogParserParasoft.license.record,LogParserIPS.license.record,LogParserHasp.license.record,LogParserEA.license.record,LogParserDSLS.license.record,LogParserCatia.system.record,PelotonEventsParser.license.pelotonevents,LogParserPeloton.license.record,DSLSEventsParser.license.dslsevents,IPSEventsParser.license.ipsevents,HaspEventsParser.license.haspevents,CatiaEventsParser.license.catiaevents,ParasoftEventsParser.license.parasoftevents,EAEventsParser.license.eaevents";
$licenseevents2_repl = "LogParserSentinel.license.event,LogParserFekete.license.event,LogParserCodeMtr.license.event,LogParserRLM.license.event,LogParserIPS.license.event,LogParserHasp.license.event,LogParserDSLS.license.event,PollParserLUM.license.event,PollParserLUM.license.event,LumEventsParser.license.lumevents,licensemeter,PelotonEventsParser.license.pelotonevents,LogParserPeloton.license.event,DSLSEventsParser.license.dslsevents,IPSEventsParser.license.ipsevents,HaspEventsParser.license.haspevents,EAEventsParser.license.eaevents,LogParserCatia.system.event";
$openit2_repl = "CatiaEventsParser.license.catiaevents,PetrelEventsParser.license.petrelevents";
$dongle_repl = "PollParserWibuKey.license.wibukey,PollParserCodemtr.license.codemeter,PollParserVector.license.vector";
$pollcollector_repl = "LogFileCollector.license.haspevents,PollCollector.system.registry";
$autodesk_repl = "PollParserAutodesk.system.autodesk";

$index  = 0;
$index = locate_line( $index, "datagroup-generation",\@lines  );
$index = locate_line( $index, "datagroups", \@lines );
$index = locate_line( $index, "licenseevents.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$licenseevents_repl/g;
$index = locate_line( $index, "licenseevents2.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$licenseevents2_repl/g;
$index = locate_line( $index, "openit2.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$openit2_repl/g;
$index = locate_line( $index, "dongle.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$dongle_repl/g;
$index = locate_line( $index, "pollcollector.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$pollcollector_repl/g;
$index = locate_line( $index, "autodesk.String", \@lines );
@lines[$index] =~ s/\"(.+?)\"/$autodesk_repl/g;

save_file( $daft, 2165, @lines );

print "-- Done updating config!\n";

# Subroutines

sub read_file {
	my ( $cfg ) = @_;
	open( FILE, "$cfg" ) or die "ERROR: Unable to read cfg '$cfg'!";
	my @lines = <FILE>;
	close( FILE );
	return @lines;
}

sub locate_line {
	my ( $start, $locate, $lines_ref ) = ( @_ );
	my ( $index ) = grep { @$lines_ref[$_] =~ /$locate/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";

	open( OUT, ">$new" ) or die "ERROR: Unable to write new cfg '$new'!";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) )
	{
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!";
	}

	if( ! rename( $new, $cfg ) )
	{
		die "ERROR: Unable to rename new config to '$cfg'!";
	}
}
